/**
File:		MachineLearning.h

Author:		
Email:		
Site:       

Copyright (c) 2017 . All rights reserved.
*/

#pragma once

// Utils
#include <MachineLearning/CommonUtil.h>
#include <MachineLearning/FgMetrics.h>
#include <MachineLearning/FgAfCv.h>
#include <MachineLearning/FgEigenvalueDecomposition.h>
#include <MachineLearning/FgKMeans.h>
#include <MachineLearning/FgCVPlot.h>
#include <MachineLearning/FgGaussHermiteQuadrature.h>
#include <MachineLearning/FgHighGUI.h>

// Embeddings
#include <MachineLearning/FgPCA.h>
#include <MachineLearning/FgLLE.h>
#include <MachineLearning/FgIsomap.h>

// Optimization
#include <MachineLearning/NonlinearObjectiveFunction.h>
#include <MachineLearning/FgLBFGSsolver.h>
#include <MachineLearning/FgLBFGSBsolver.h>
#include <MachineLearning/FgAdamSolver.h>
#include <MachineLearning/FgAdaMaxSolver.h>
#include <MachineLearning/FgNadamSolver.h>
#include <MachineLearning/FgSCG.h>

// Kernel
#include <MachineLearning/FgKernels.h>

// Back-constraints
#include <MachineLearning/FgBackconstraints.h>

// Graph
#include <MachineLearning/FgDiscreteGraph.h>
#include <MachineLearning/FgDiscreteFactorNode.h>
#include <MachineLearning/FgDiscreteVariableNode.h>
#include <MachineLearning/FgDiscreteMessage.h>
#include <MachineLearning/FgGaussianMessage.h>
#include <MachineLearning/FgMessageBox.h>
#include <MachineLearning/FgPotential.h>
#include <MachineLearning/FgDiscreteFactorNode.h>
#include <MachineLearning/FgDiscreteVariableNode.h>
#include <MachineLearning/FgGPNode.h>

// Models
#include <MachineLearning/FgPEPSparseGPR.h>
#include <MachineLearning/FgAEPSparseGPR.h>
#include <MachineLearning/FgAEPSparseDGPR.h>
#include <MachineLearning/FgAEPSparseGPLVM.h>
#include <MachineLearning/FgAEPSparseDGPLVM.h>
#include <MachineLearning/FgAEPSparseGPSSM.h>
#include <MachineLearning/FgAEPSparseDGPSSM.h>
#include <MachineLearning/FgBlendshapeSGPR.h>
//#include <MachineLearning/FgPEPSparseGPLVM.h>
//#include <MachineLearning/FgVFESparseGPLVM.h>
//#include <MachineLearning/FgVFESparseGPR.h>

#include <MachineLearning/FgLikelihoodBaseLayer.h>
#include <MachineLearning/FgGaussLikelihoodLayer.h>
#include <MachineLearning/FgProbitLikelihoodLayer.h>

#include <MachineLearning/FgGaussEmissionLayer.h>

#include <MachineLearning/FgGPBaseLayer.h>
#include <MachineLearning/FgSparseGPBaseLayer.h>
//#include <MachineLearning/FgPEPSparseGPLayer.h>
#include <MachineLearning/FgAEPSparseGPLayer.h>
//#include <MachineLearning/FgVFESparseGPLayer.h>
